//
//  TDDocument.m
//  ToDo
//
//  Created by narita on 2013/10/13.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "TDDocument.h"

@implementation TDDocument

- (id)init
{
    self = [super init];
    if (self)
    {
        // Add your subclass-specific initialization here.
        
        self.selectedIndex = [NSIndexSet indexSet];
        self.sortDescriptorArray = [NSArray array];
    }
    return self;
}

- (NSString *)windowNibName
{
    // Override returning the nib file name of the document
    // If you need to use a subclass of NSWindowController or if your document supports multiple NSWindowControllers, you should remove this method and override -makeWindowControllers instead.
    return @"TDDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *)aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
}

+ (BOOL)autosavesInPlace
{
    return YES;
}

// うまく動いてくれないので、encodeRestorableStateWithCoderとrestoreStateWithCoderをオーバーライドした
//+ (NSArray *)restorableStateKeyPaths
//{
//    return [[super restorableStateKeyPaths] arrayByAddingObjectsFromArray:@[ @"selectedIndex", @"sortDescriptorArray" ]];
//}

- (void) setSelectedIndex:(NSIndexSet *)selectedIndex
{
    _selectedIndex = selectedIndex;
    [self invalidateRestorableState];
}

- (void) setSortDescriptorArray:(NSArray *)sortDescriptorArray
{
    _sortDescriptorArray = sortDescriptorArray;
    [self invalidateRestorableState];
}

- (void)encodeRestorableStateWithCoder:(NSCoder *)coder
{
    [super encodeRestorableStateWithCoder:coder];
    
    // 何故かNSArrayControllerに対するselectedIndexsが保存復帰出来ない
    [coder encodeObject:self.selectedIndex
                 forKey:@"selectedIndex"];
    
    [coder encodeObject:self.sortDescriptorArray
                 forKey:@"sortDescriptorArray"];
}

- (void)restoreStateWithCoder:(NSCoder *)coder
{
    [super restoreStateWithCoder:coder];
    
    // 何故かNSArrayControllerに対するselectedIndexsが保存復帰出来ない
    self.selectedIndex = [coder decodeObjectForKey:@"selectedIndex"];
    self.sortDescriptorArray = [coder decodeObjectForKey:@"sortDescriptorArray"];
}

@end
