//
//  TDDocument.m
//  ToDo
//
//  Created by narita on 2013/10/13.
//  Copyright (c) 2013年 narita. All rights reserved.
//

#import "TDDocument.h"
#import "TDWindowController.h"

@implementation TDDocument

- (id)init
{
    self = [super init];
    if (self)
    {
        // Add your subclass-specific initialization here.
    }
    return self;
}

- (void)windowControllerDidLoadNib:(NSWindowController *)aController
{
    [super windowControllerDidLoadNib:aController];
    // Add any code here that needs to be executed once the windowController has loaded the document's window.
}

+ (BOOL)autosavesInPlace
{
    return YES;
}

#define kTDWindowIdentifierLabel @"TDWindowController:"

- (void) synchronizeWindowIdentifier
{
    for( TDWindowController* i in self.windowControllers )
    {
        i.window.identifier = [NSString stringWithFormat:(kTDWindowIdentifierLabel @"%lu"),
                               [self.windowControllers indexOfObject:i]];
    }
}

- (void)restoreDocumentWindowWithIdentifier:(NSString *)identifier
                                      state:(NSCoder *)state
                          completionHandler:(void (^)(NSWindow *, NSError *))completionHandler
{    
    if ([identifier hasPrefix:kTDWindowIdentifierLabel])
    {
        NSString* theIndexString = [identifier substringFromIndex:[kTDWindowIdentifierLabel length]];
        NSInteger theIndex       = [theIndexString integerValue];
        NSWindow* theWindow = nil;

        if( self.windowControllers.count > theIndex )
        {
            theWindow = [self.windowControllers objectAtIndex:theIndex];
        }
        else
        {
            TDWindowController* theWindowController;
            
            theWindowController = [self makeNewWindowController];
            
            theWindow = theWindowController.window;
        }
        
        completionHandler(theWindow, nil);
    }
    else
    {
        [super restoreDocumentWindowWithIdentifier:identifier
                                             state:state
                                 completionHandler:completionHandler];
    }
}

- (Class) windowControllerClass
{
    return [TDWindowController class];
}

- (IBAction)makeNewWindow:(id)sender
{
    [self makeNewWindowController];
}

- (TDWindowController*) makeNewWindowController
{
    TDWindowController*	theController;
    Class			    theWindowCtrlClass;
            
    theWindowCtrlClass = [self windowControllerClass];
    
    theController = [[theWindowCtrlClass alloc] init];
    
    [self addWindowController:theController];
    [theController showWindow:self];
    
    return theController;
}

// ---------------------------------------------------------------------------
//	makeWindowControllers
// ---------------------------------------------------------------------------
//	このDocumentオブジェクトのWindowを作成し表示する
//
- (void) makeWindowControllers
{
    [self makeNewWindow:self];
}

// ---------------------------------------------------------------------------
//	addWindowController
// ---------------------------------------------------------------------------
//	ウインドウが追加された場合のタイトルの書き換え
//

- (void)addWindowController: (NSWindowController *)windowController
{
    [super addWindowController:windowController];
    
    [[self windowControllers] makeObjectsPerformSelector:@selector(synchronizeWindowTitleWithDocumentName)];
    [self synchronizeWindowIdentifier];
}

// ---------------------------------------------------------------------------
//	removeWindowController
// ---------------------------------------------------------------------------
//	ウインドウが削除された場合のタイトルの書き換え
//

- (void)removeWindowController: (NSWindowController *)windowController
{
    [super removeWindowController:windowController];
    
    [[self windowControllers] makeObjectsPerformSelector:@selector(synchronizeWindowTitleWithDocumentName)];
    [self synchronizeWindowIdentifier];
}

@end
